﻿using MediatR;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace DemoCQRS.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class TestesController : ControllerBase
    {
        private readonly IMediator _mediator;
        public TestesController(IMediator mediator)
        {
            _mediator = mediator;
        }

        [HttpGet]
        public async System.Threading.Tasks.Task<IEnumerable<string>> GetAsync()
        {
            return await _mediator.Send(new Services.Queries.GetValuesQuery.Query());
        }
        
        [HttpGet("{id}")]
        public string Get(int id)
        {
            return "value";
        }

        [HttpPost]
        public async Task Post([FromBody] string value)
        {
            await _mediator.Send(new Services.Commands.AddValueCommand.Command
            {
                Value = value
            });
            await _mediator.Publish(new Services.Notifications.ValueAddedNotification { Value = value });
        }

        [HttpPut("{id}")]
        public void Put(int id, [FromBody] string value)
        {
        }
        
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}
