﻿using DemoCQRS.Data;
using MediatR;

namespace DemoCQRS.Services.Commands
{
    public class AddValueCommand
    {
        public class Command : IRequest
        {
            public string Value { get; set; }
        }
        public class Handler : RequestHandler<Command>
        {
            private readonly FakeData _db;
            public Handler(FakeData db)
            {
                _db = db;   
            }
            protected override void Handle(Command request)
            {
                _db.AddValue(request.Value);
            }
        }
    }
}
