﻿using DemoCQRS.Data;
using MediatR;
using System.Threading;
using System.Threading.Tasks;

namespace DemoCQRS.Services.Notifications
{
    public class EmailNotificationHandler : INotificationHandler<ValueAddedNotification>
    {
        private readonly FakeData _fakeDataStore;
        public EmailNotificationHandler(FakeData fakeDataStore)
        {
            _fakeDataStore = fakeDataStore;
        }
        public Task Handle(ValueAddedNotification notification, CancellationToken cancellationToken)
        {
            _fakeDataStore.EventOccured(notification.Value, "Email enviado");
            return Task.CompletedTask;
        }
    }
}
