﻿using DemoCQRS.Data;
using MediatR;
using System.Collections.Generic;

namespace DemoCQRS.Services.Queries
{
    public class GetValuesQuery
    {
        public class Query : IRequest<IEnumerable<string>> { }
        public class Handler : RequestHandler<Query, IEnumerable<string>>
        {
            private readonly FakeData _db;
            public Handler(FakeData db)
            {
                _db = db;
            }
            protected override IEnumerable<string> Handle(Query request)
            {
                return _db.GetAllValues();
            }
        }
    }
}
